# -*- coding: utf-8 -*-
"""Clustering code.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1IGCPX2k5ieoSExCKuaBpfqYXfvxYQHSU
"""

##Question 1: read CSV file##
from google.colab import files

uploaded = files.upload()

import pandas as pd
data= pd.read_csv("AllData.csv")
data

df= pd.DataFrame()
df['CO2_Emissions']=data.CO2_Emissions
df['Noise']=data.Bruit
df['TV_Power_Consumed']=data.TV_Power_Consumed
df['Total_Power']=data.Total_Power

##Q13: Re-solve the problem using clustering method (K-mean)##
import pandas as pd
import numpy as nm    
import matplotlib.pyplot as mtp    
from sklearn.cluster import KMeans  
import numpy as np 
import random as rd
from sklearn.model_selection import train_test_split # Import train_test_split function
import matplotlib.pyplot as plt

X=df
wcss_list= []  #Initializing the list for the values of WCSS  
#Using for loop for iterations from 1 to 10.  
for i in range(1, 11):  
    kmeans = KMeans(n_clusters=i, init='k-means++', random_state= 42)  
    kmeans.fit(X)  
    wcss_list.append(kmeans.inertia_)  
mtp.plot(range(1, 11), wcss_list)  
mtp.title('The Elbow Method Graph')  
mtp.xlabel('Number of clusters(k)')  
mtp.ylabel('wcss_list')  
mtp.show()  

K=4

# Select random observation as centroids
Centroids = (X.sample(n=K))
plt.scatter(X["CO2_Emissions"],X["Total_Power"],c='black')
plt.scatter(Centroids["CO2_Emissions"],Centroids["Total_Power"],c='red')
plt.xlabel('CO2 Emissions')
plt.ylabel('Total Power')
plt.show()

# Step 3 - Assign all the points to the closest cluster centroid
# Step 4 - Recompute centroids of newly formed clusters
# Step 5 - Repeat step 3 and 4

diff = 1
j=0

while(diff!=0):
    XD=X
    i=1
    for index1,row_c in Centroids.iterrows():
        ED=[]
        for index2,row_d in XD.iterrows():
            d1=(row_c["CO2_Emissions"]-row_d["Total_Power"])**2
            d2=(row_c["CO2_Emissions"]-row_d["Total_Power"])**2
            d=np.sqrt(d1+d2)
            ED.append(d)
        X[i]=ED
        i=i+1

    C=[]
    for index,row in X.iterrows():
        min_dist=row[1]
        pos=1
        for i in range(K):
            if row[i+1] < min_dist:
                min_dist = row[i+1]
                pos=i+1
        C.append(pos)
    X["Cluster"]=C
    Centroids_new = X.groupby(["Cluster"]).mean()[["CO2_Emissions","Total_Power"]]
    if j == 0:
        diff=1
        j=j+1
    else:
        diff = (Centroids_new['CO2_Emissions'] - Centroids['CO2_Emissions']).sum() + (Centroids_new['Total_Power'] - Centroids['Total_Power']).sum()
        #print(diff.sum())
    Centroids = X.groupby(["Cluster"]).mean()[["CO2_Emissions","Total_Power"]]

color=['blue','green','cyan']
for k in range(K):
    data=X[X["Cluster"]==k+1]
    plt.scatter(data["CO2_Emissions"],data["Total_Power"],c=color[k])
    plt.scatter(Centroids["CO2_Emissions"],Centroids["Total_Power"],c='red')
plt.show()

##Q15: Compare the classification solution with the clustering solution##
import pandas as pd
import time

Testing = df.iloc[501:,:]
def clustering(nb_cluster,testing):
    t1=time.time()
    X=[]
    L1=list(df.CO2_Emissions)
    L2=list(df.Total_Power)
    L3=list(df.Noise)
    L4=list(df.TV_Power_Consumed)
    for k in range (len(L1)):
        X.append([L1[k],L2[k],L3[k],L4[k]])
    Y=KMeans(init="k-means++", n_clusters=nb_cluster, n_init=10).fit_predict(X)
    plt.subplot(1,2,1)
    plt.scatter(L1,L2, c=Y)
    plt.xlabel("CO2 Emissions")
    plt.ylabel("Total Power")
    plt.subplot(1,2,2)
    plt.scatter(L3,L4, c=Y)
    plt.xlabel("Noise")
    plt.ylabel("TV Power")
    

clustering(4,Testing)
plt.show()